Public Class clsHalloWeltBedingung
    Inherits BedingungBasis.clsBedingungBasis

    Public Sub New(ByVal wsurl As String)
        MyBase.New(wsurl)

        Klassen.clsBasisklasse.WSUrl = wsurl
    End Sub

    Public Overrides Function Pruefen(ByVal Parameter As List(Of Object)) As List(Of Object)
        'Variablendeklaration:
        Dim Vorgang As Klassen.clsVorgangClient
        Dim Artikel As Klassen.clsArtikel
        Dim Kundenadresse As Klassen.clsAdresse
        Dim Benutzer As Klassen.clsAdresse

        Dim Warnung As Boolean = False
        Dim WarnungText As String = ""
        Dim NichtErfuellt As Boolean = False
        Dim NichtErfuelltText As String = ""
        Dim ErfuelltText As String = ""

        Try
            '--------------------------------------------------------------Hier Folgt Ihr Quellcode--------------------------------------------------------------'
            'myCurrentVorgangClientID '                                                                     enthlt die VorgangsID
            'myCurrentStatusID '                                                                            enthlt die StatusID des Status, in den gewechselt wird
            'myCurrentBenutzerID '                                                                          enthlt die BenutzerID des Benutzers, der das Ereignis aufgerufen hat

            Vorgang = New Klassen.clsVorgangClient(myCurrentVorgangClientID) '                              Vorgang instanzieren
            If Vorgang.Adresse_ID > 0 Then '                                                                Kundenadresse des aktuellen Vorgangs auslesen
                Kundenadresse = New Klassen.clsAdresse(Vorgang.Adresse_ID) '                                Kundenadresse instanzieren
                If Not Kundenadresse Is Nothing Then
                    ErfuelltText = "Hallo " & Kundenadresse.Name1 & "!" '                                   Beispieltext fr "BedingungErfuellt"
                End If
            End If

            Benutzer = New Klassen.clsAdresse(myCurrentBenutzerID) '                                        Benutzer instanzieren
            If Not Benutzer Is Nothing Then
                If Not ErfuelltText = "" Then ErfuelltText &= " - " '                                       Trennzeichen, falls bereits etwas in "ErfuelltText"
                ErfuelltText &= "Hallo " & Benutzer.Name1 & "!" '                                           Beispieltext fr "BedingungErfuellt"
            End If

            If Vorgang.VorgangsPositionen Is Nothing OrElse Vorgang.VorgangsPositionen.Count = 0 Then '     Wenn keine Positionen vorhanden sind, Warnung ausgeben:
                Warnung = True '                                                                            Warnung anzeigen, siehe "Return ..."
                WarnungText = "Achtung! Keine Positionen"
            ElseIf Vorgang.VorgangsPositionen.Count > 10 Then '                                             Wenn mehr als 10 Positionen vorhanden sind, "NichtErfuellt" ausgeben:
                NichtErfuellt = True '                                                                      "NichtErfuellt" anzeigen, siehe "Return ..."
                NichtErfuelltText = "zu viele Positionen (" & Vorgang.VorgangsPositionen.Count & ")"
            Else
                For Each Position As Klassen.clsVorgangsPositionClient In Vorgang.VorgangsPositionen '      Positionen des Vorgangs durchgehen
                    Artikel = New Klassen.clsArtikel(Position.Artikel_ID) '                                 Der Artikel der aktuellen Position
                    If Not ErfuelltText = "" Then ErfuelltText &= " - " '                                   Trennzeichen, falls bereits etwas in "ErfuelltText"
                    ErfuelltText &= "Hallo " & Artikel.Kurztext & "!" '                                     Beispieltext fr "BedingungErfuellt"
                Next
            End If
            '----------------------------------------------------------------------------------------------------------------------------------------------------'

            If NichtErfuellt = True Then
                Return New List(Of Object)() From {Bedingungsstatus.BedingungNichtErfuellt, NichtErfuelltText} '    Zeigt ein Nicht-Erfuellt-Symbol und mitgegebenen Text an, lsst die Ereignisausfhrung NICHT zu.
            ElseIf Warnung = True Then
                Return New List(Of Object)() From {Bedingungsstatus.Warnung, WarnungText} '                         Zeigt ein Warnsymbol und mitgegebenen Text an, lsst aber die Ereignisausfhrung zu.
            Else
                Return New List(Of Object)() From {Bedingungsstatus.BedingungErfuellt, ErfuelltText} '              Zeigt ein OK-Symbol und mitgegebenen Text an, lsst die Ereignisausfhrung zu.
            End If
        Catch ex As Exception
            Log(ex.Message & ex.StackTrace) 'Legt den mitgegebenen Text als Logeintrag unter "---UniERM-Client---\Logs\bedingungslog\" in der Datei fr den jeweiligen Monat an.
            Return New List(Of Object)() From {Bedingungsstatus.Fehler, ex.Message} 'Zeigt ein Fehler-Symbol und mitgegebenen Text an, lsst die Ereignisausfhrung NICHT zu.
        End Try

    End Function
End Class
