Public Class clsHalloWeltEreignisFortgeschritten
    Inherits EreignisBasis.clsEreignisBasis

    Public Sub New(ByVal wsurl As String)
        MyBase.New(wsurl)

        Klassen.clsBasisklasse.WSUrl = wsurl
    End Sub

    '++++++++++++++++++++++++++++++Fortgeschritten++++++++++++++++++++++++++++++'
    ''' <summary>
    ''' Wenn hier "True" zurckgegeben wird, erscheint ein Benutzerdialog im Webpart "Konfiguration Vorgangstypen" unter Optionen, wenn ein Ereignis hinzugefgt wird.
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Overrides ReadOnly Property Flag_BenoetigtKonfigurationsdaten As Boolean
        Get
            Return True
        End Get
    End Property

    ''' <summary>
    ''' Wenn hier "True" zurckgegeben wird, erscheint ein Eingabebereich unter den Bedingungen, wenn der Status am Vorgang gewechselt wird.
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Overrides ReadOnly Property Flag_BenoetigtDynamischeKonfigurationsdatenFrage As Boolean
        Get
            Return True
        End Get
    End Property

    ''' <summary>
    ''' Die Steuerelemente die im Dialog angezeigt werden sollen, um z.B. einen Dateinamen fr eine generierte Datei zu bergeben
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Protected Overrides ReadOnly Property myVoreinstellungen As EreignisBasis.clsEreignisBasis.sErweiterteEinstellungenEreignis
        Get
            Dim Voreinstellungen As New sErweiterteEinstellungenEreignis

            'Es gibt drei Anzeigearten: 
            '- enuAnzeigeart.Vorgangskonfiguration:             Das Steuerelement erscheint im Webpart "Konfiguration Vorgangstypen"
            '- enuAnzeigeart.Benutzerfrage:                     Das Steuerelement erscheint im Eingabebereich unter den Bedingungen
            '- enuAnzeigeart.Immer:                             Das Steuerelement erscheint in beiden Bereichen

            'Aktuell gibt es folgende Steuerelemente, welche sich hauptschlich nach ihren Datentypen richten:
            '- enuEingabeartDatentyp.TextboxString              Eine Textbox die den Datentyp "String" fr die Eingabe erlaubt
            '- enuEingabeartDatentyp.TextboxMultilineString     Eine mehrzeilige Textbox die den Datentyp "String" fr die Eingabe erlaubt
            '- enuEingabeartDatentyp.TextboxInt                 Eine Textbox die den Datentyp "Integer" fr die Eingabe erlaubt
            '- enuEingabeartDatentyp.TextboxTime                Eine Textbox die den Datentyp "Zeit" fr die Eingabe erlaubt
            '- enuEingabeartDatentyp.TextboxDouble              Eine Textbox die den Datentyp "Double" fr die Eingabe erlaubt
            '- enuEingabeartDatentyp.TextboxDate                Eine Textbox die den Datentyp "Datum" fr die Eingabe erlaubt

            '- enuEingabeartDatentyp.CheckboxBoolean            Eine Checkbox die den Datentyp "Boolean" fr die Eingabe erlaubt

            '- enuEingabeartDatentyp.ButtonListeString          Zeigt pro Listeneintrag einen "Button" mit dem Eintrag als Beschriftung an, die Beschriftung des gedrckten Buttons wird zurckgegeben

            '- enuEingabeartDatentyp.DDLString                  Zeigt eine "DropDownList"/"Combobox" mit der bergebenen Liste als Auswahlmglichkeiten an, gibt den Ausgewhlten Eintrag zurck

            '- enuEingabeartDatentyp.Label                      Zeigt den bergebenen Wert als einfachen Text an (z.B. als berschrift)


            'Zeigt im Webpart "Konfiguration Vorgangstypen" und im Eingabebereich unter den Bedingungen eine Textbox mit dem 
            'Datentyp "Integer", dem Standardwert "0" dem Namen "Nummer" und der Beschriftung "Nummer:" an.
            'Normalerweise werden im Webpart "Konfiguration Vorgangstypen" die Voreinstellungen von einem Administrator festgelegt
            'und im Eingabebereich unter den Bedingungen knnen normale Benutzer Daten eingeben.
            Voreinstellungen.AddControl("Nummer", "Nummer:", enuEingabeartDatentyp.TextboxInt, "0", enuAnzeigeart.Immer)

            'Zeigt im Webpart "Konfiguration Vorgangstypen" eine Textbox mit dem Datentyp "String", dem Standardwert "Vorgang%Vorgang.ID%.dat" (mehr zu "%Vorgang.ID%" weiter unten) 
            'dem Namen "Dateiname" und der Beschriftung "Dateiname:" an.
            Voreinstellungen.AddControl("Dateiname", "Dateiname:", enuEingabeartDatentyp.TextboxString, "Vorgang%Vorgang.ID%.dat", enuAnzeigeart.Vorgangskonfiguration)

            'Achtung! Folgende Zeichen/Eingaben sind durch UniERM oder ASP nicht erlaubt, sie sollten nicht als 'Name/Beschriftung/Werte benutzt werden:
            'HTML-Tags (diese knnen jedoch vom Benutzer eingegeben werden da sie im Hintergrund umgewandelt werden) 
            '"/" und "|" werden als Trennzeichen benutzt und sind nicht verfgbar

            Return Voreinstellungen
        End Get
    End Property
    '+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++'

    Public Overrides Function AusfuehrenWebAnwendung(ByVal Parameter As List(Of Object), ByVal page As Web.UI.Page) As List(Of Object)

        'Variablendeklaration:
        Dim Vorgang As Klassen.clsVorgangClient
        Dim Artikel As Klassen.clsArtikel
        Dim Kundenadresse As Klassen.clsAdresse
        Dim Benutzer As Klassen.clsAdresse

        Dim Warnung As Boolean = False
        Dim WarnungText As String = ""
        Dim FehlerBeiEreignisAusfuehrung As Boolean = False
        Dim FehlerBeiEreignisAusfuehrungText As String = ""
        Dim EreignisAusgefuehrtText As String = ""

        Dim openScript As String = ""

        Dim tmpNummer As String
        Dim Nummer As Integer
        Dim Dateiname As String

        Dim Table As Data.DataTable

        Try
            '--------------------------------------------------------------Hier Folgt Ihr Quellcode--------------------------------------------------------------'
            'myCurrentVorgangClientID '                                                                 enthlt die VorgangsID
            'myCurrentStatusID '                                                                        enthlt die StatusID des Status, in den gewechselt wird
            'myCurrentBenutzerID '                                                                      enthlt die BenutzerID des Benutzers, der das Ereignis aufgerufen hat
            'myCurrentErweiterteEinstellungen '                                                         enthlt, falls vorhanden, die erweiterten Einstellungen

            '++++++++++++++++++++++++++++++Fortgeschritten++++++++++++++++++++++++++++++'

            'So werden die Werte aus den Voreinstellungen wieder ausgelesen:
            Dateiname = ""
            tmpNummer = ""
            Nummer = Integer.MinValue
            If Not myCurrentErweiterteEinstellungen Is Nothing Then
                tmpNummer = myCurrentErweiterteEinstellungen.GetControlValue("Nummer") '                Liest den Wert des Steuerelements mit dem Namen "Nummer" aus
                If Not tmpNummer = "" AndAlso IsNumeric(tmpNummer) = True Then '                        Nullwerte abfangen
                    Nummer = CInt(tmpNummer)
                End If

                Dateiname = myCurrentErweiterteEinstellungen.GetControlValue("Dateiname") '             Liest den Wert des Steuerelements mit dem Namen "Dateiname" aus
                If Not Dateiname = "" Then '                                                            Nullwerte abfangen


                    'Die Funktion "ScriptingReplaceString" bietet die Mglichkeit simple Eingenschaften folgender Objekte auszulesen:
                    '- %Vorgang.//Vorgangseingenschaft//%               Achtung! "//Vorgangseingenschaft//" muss von der Gro- und Kleinschreibung genau mit den Eigenschaften der Klasse clsVorgangClient bereinstimmen
                    '- %Benutzer.//Benutzereingenschaft//%              Achtung! "//Benutzereingenschaft//" muss von der Gro- und Kleinschreibung genau mit den Eigenschaften der Klasse clsAdresse bereinstimmen
                    '- %Vorgang.Vorgangspositionen%                     Gibt eine einfache Liste der Artikel des Vorgangs aus: "/Kurztext/ Menge: /Artikelmenge/" & Zeilenumbruch

                    'Diese Funktion ist Hilfreich um den Benutzern die Mglichkeit zu geben in der Oberflche einige Werte nach den jeweiligen Bedrfnissen dynamisch anzupassen, ohne 
                    'jedes mal ein neues Ereignis zu kompilieren. (Zum Beispiel fr die Vorgangsnummer in einem Dateinamen oder den Text einer Email mit Werten aus dem Vorgang)

                    'Achtung! Die Funktion sollte mit bedacht eingesetzt werden und in der Regel nur fr Werte, welche ber das Webpart "Konfiguration Vorgangstypen" eingestellt und
                    'somit nur von Administratoren benutzt werden, da der Zugriff auf diverse Benutzer und Vorgangswerte ermglicht wird.
                    Dateiname = Klassen.clsFunktionen.ScriptingReplaceString(Dateiname, myCurrentVorgangClientID, myCurrentBenutzerID)
                End If
            End If

            '+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++'

            Vorgang = New Klassen.clsVorgangClient(myCurrentVorgangClientID) '                          Vorgang instanzieren
            Vorgang.Bezeichnung = Vorgang.Bezeichnung '                                                 WICHTIG! Wert in die Datenbank schreiben. Dies bewirkt, das der Benutzer eingetragen wird, der spter auf dem Report steht.
            If Vorgang.Adresse_ID > 0 Then '                                                            Kundenadresse des aktuellen Vorgangs auslesen
                Kundenadresse = New Klassen.clsAdresse(Vorgang.Adresse_ID) '                            Kundenadresse instanzieren
                If Not Kundenadresse Is Nothing Then
                    EreignisAusgefuehrtText = "Hallo " & Kundenadresse.Name1 & "!" '                    Beispieltext fr "EreignisAusgefuehrt"
                End If
            End If

            Benutzer = New Klassen.clsAdresse(myCurrentBenutzerID) '                                    Benutzer instanzieren
            If Not Benutzer Is Nothing Then
                If Not EreignisAusgefuehrtText = "" Then EreignisAusgefuehrtText &= " - " '             Trennzeichen, falls bereits etwas in "EreignisAusgefuehrtText" steht
                EreignisAusgefuehrtText &= "Hallo " & Benutzer.Name1 & "!" '                            Beispieltext fr "EreignisAusgefuehrt"
            End If

            If Vorgang.VorgangsPositionen Is Nothing OrElse Vorgang.VorgangsPositionen.Count = 0 Then ' Wenn keine Positionen vorhanden sind, Warnung ausgeben:
                Warnung = True '                                                                        Warnung anzeigen, siehe "Return ..."
                WarnungText = "Achtung! Keine Positionen"
            Else
                '++++++++++++++++++++++++++++++Fortgeschritten++++++++++++++++++++++++++++++'
                If Not EreignisAusgefuehrtText = "" Then EreignisAusgefuehrtText &= " - " '             Trennzeichen, falls bereits etwas in "EreignisAusgefuehrtText" steht
                EreignisAusgefuehrtText &= "Nummer " & Nummer & "!" '                                   Beispieltext fr "EreignisAusgefuehrt"
                '+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++'

                For Each Position As Klassen.clsVorgangsPositionClient In Vorgang.VorgangsPositionen '  Positionen des Vorgangs durchgehen
                    Artikel = New Klassen.clsArtikel(Position.Artikel_ID) '                             Der Artikel der aktuellen Position
                    If Not EreignisAusgefuehrtText = "" Then EreignisAusgefuehrtText &= " - " '         Trennzeichen, falls bereits etwas in "EreignisAusgefuehrtText" steht
                    EreignisAusgefuehrtText &= "Hallo " & Artikel.Kurztext & "!" '                      Beispieltext fr "EreignisAusgefuehrt"
                Next
            End If

            '++++++++++++++++++++++++++++++Fortgeschritten++++++++++++++++++++++++++++++'

            'Die Dateianhnge des Vorgangs Absteigend sortiert auslesen:
            Table = Klassen.clsFunktionen.GetList(New Data.SqlClient.SqlCommand("SELECT ID FROM DateiAnhang WHERE (TabellenName LIKE 'VorgangClient') AND (ObjektID = " & myCurrentVorgangClientID & ") ORDER BY ID DESC"))
            If Table IsNot Nothing AndAlso Table.Rows.Count > 0 Then
                'Der dritte Rckgabeparameter (siehe unten), ermglicht es Javascript an den UniERM-Client zurckzugeben, in diesem Fall wird ein neues Fenster mit dem
                'letzten Dateianhang angezeigt. 
                'Achtung! Zu bedenken ist das der in diesem Beispiel benutzte Handler "FileHandler.ashx" aus Sicherheitsgrnden Dateianhnge nur fr den Benutzer anzeigt der diese erstellt hat.
                openScript = "var filteransicht = window.open('FileHandler.ashx?id=" & Table.Rows(0).Item("ID") & "', " & _
                             "'Datei', " & _
                             "'width=600,height=600,left=150,top=150,resizable=1,scrollbars=1');"
            End If

            '+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++'

            '----------------------------------------------------------------------------------------------------------------------------------------------------'

            If FehlerBeiEreignisAusfuehrung = True Then
                Return New List(Of Object) From {Ereignisstatus.FehlerBeiEreignisAusfuehrung, FehlerBeiEreignisAusfuehrungText} '   Zeigt ein Fehler-Symbol und mitgegebenen Text an.
            ElseIf Warnung = True Then
                Return New List(Of Object) From {Ereignisstatus.Warnung, WarnungText} '                                             Zeigt ein Warnsymbol und mitgegebenen Text an.
            Else
                Return New List(Of Object) From {Ereignisstatus.EreignisAusgefuehrt, EreignisAusgefuehrtText, openScript} '         Zeigt ein OK-Symbol und mitgegebenen Text an und ffnet ein neues Fenster falls ein Dateianhang vorhanden ist.
            End If
        Catch ex As Exception
            Log(ex.Message & vbCrLf & ex.Source) ' Legt den mitgegebenen Text als Logeintrag unter "---UniERM-Client---\Logs\ereignislog\" in der Datei fr den jeweiligen Monat an.
            Return New List(Of Object) From {Ereignisstatus.FehlerBeiEreignisAusfuehrung, ex.Message} 'Zeigt ein Fehler-Symbol und mitgegebenen Text an.
        End Try
    End Function
End Class
