Public Class clsHalloWeltEreignis
    Inherits EreignisBasis.clsEreignisBasis

    Public Sub New(ByVal wsurl As String)
        MyBase.New(wsurl)

        Klassen.clsBasisklasse.WSUrl = wsurl
    End Sub

    Public Overrides Function AusfuehrenWebAnwendung(ByVal Parameter As List(Of Object), ByVal page As Web.UI.Page) As List(Of Object)
        'Variablendeklaration:
        Dim Vorgang As Klassen.clsVorgangClient
        Dim Artikel As Klassen.clsArtikel
        Dim Kundenadresse As Klassen.clsAdresse
        Dim Benutzer As Klassen.clsAdresse

        Dim Warnung As Boolean = False
        Dim WarnungText As String = ""
        Dim FehlerBeiEreignisAusfuehrung As Boolean = False
        Dim FehlerBeiEreignisAusfuehrungText As String = ""
        Dim EreignisAusgefuehrtText As String = ""

        Try
            '--------------------------------------------------------------Hier Folgt Ihr Quellcode--------------------------------------------------------------'
            'myCurrentVorgangClientID '                                                                 enthlt die VorgangsID
            'myCurrentStatusID '                                                                        enthlt die StatusID des Status, in den gewechselt wird
            'myCurrentBenutzerID '                                                                      enthlt die BenutzerID des Benutzers, der das Ereignis aufgerufen hat

            Vorgang = New Klassen.clsVorgangClient(myCurrentVorgangClientID) '                          Vorgang instanzieren
            Vorgang.Bezeichnung = Vorgang.Bezeichnung '                                                 WICHTIG! Wert in die Datenbank schreiben. Dies bewirkt, das der Benutzer eingetragen wird, der spter auf dem Report steht.
            If Vorgang.Adresse_ID > 0 Then '                                                            Kundenadresse des aktuellen Vorgangs auslesen
                Kundenadresse = New Klassen.clsAdresse(Vorgang.Adresse_ID) '                            Kundenadresse instanzieren
                If Not Kundenadresse Is Nothing Then
                    EreignisAusgefuehrtText = "Hallo " & Kundenadresse.Name1 & "!" '                    Beispieltext fr "BedingungErfuellt"
                End If
            End If

            Benutzer = New Klassen.clsAdresse(myCurrentBenutzerID) '                                    Benutzer instanzieren
            If Not Benutzer Is Nothing Then
                If Not EreignisAusgefuehrtText = "" Then EreignisAusgefuehrtText &= " - " '             Trennzeichen, falls bereits etwas in "EreignisAusgefuehrtText" steht
                EreignisAusgefuehrtText &= "Hallo " & Benutzer.Name1 & "!" '                            Beispieltext fr "EreignisAusgefuehrt"
            End If

            If Vorgang.VorgangsPositionen Is Nothing OrElse Vorgang.VorgangsPositionen.Count = 0 Then ' Wenn keine Positionen vorhanden sind, Warnung ausgeben:
                Warnung = True '                                                                        Warnung anzeigen, siehe "Return ..."
                WarnungText = "Achtung! Keine Positionen"
            ElseIf Vorgang.Fertiggestellt = True Then '                                                 Wenn der Vorgang bereits fertiggestellt ist, Fehler ausgeben
                FehlerBeiEreignisAusfuehrung = True
                FehlerBeiEreignisAusfuehrungText = "Fehler! Vorgang bereits fertiggestellt"
            Else
                Vorgang.Fertiggestellt = True '                                                         Vorgang fertigstellen (Bucht je nach Vorgang Mengen)

                For Each Position As Klassen.clsVorgangsPositionClient In Vorgang.VorgangsPositionen '  Positionen des Vorgangs durchgehen
                    Artikel = New Klassen.clsArtikel(Position.Artikel_ID) '                             Der Artikel der aktuellen Position
                    If Not EreignisAusgefuehrtText = "" Then EreignisAusgefuehrtText &= " - " '         Trennzeichen, falls bereits etwas in "EreignisAusgefuehrtText" steht
                    EreignisAusgefuehrtText &= "Hallo " & Artikel.Kurztext & "!" '                      Beispieltext fr "EreignisAusgefuehrt"
                Next
            End If
            '----------------------------------------------------------------------------------------------------------------------------------------------------'

            If FehlerBeiEreignisAusfuehrung = True Then
                Return New List(Of Object) From {Ereignisstatus.FehlerBeiEreignisAusfuehrung, FehlerBeiEreignisAusfuehrungText} '   Zeigt ein Fehler-Symbol und mitgegebenen Text an.
            ElseIf Warnung = True Then
                Return New List(Of Object) From {Ereignisstatus.Warnung, WarnungText} '                                             Zeigt ein Warnsymbol und mitgegebenen Text an.
            Else
                Return New List(Of Object) From {Ereignisstatus.EreignisAusgefuehrt, EreignisAusgefuehrtText} '                     Zeigt ein OK-Symbol und mitgegebenen Text an.
            End If
        Catch ex As Exception
            Log(ex.Message & vbCrLf & ex.Source) ' Legt den mitgegebenen Text als Logeintrag unter "---UniERM-Client---\Logs\ereignislog\" in der Datei fr den jeweiligen Monat an.
            Return New List(Of Object) From {Ereignisstatus.FehlerBeiEreignisAusfuehrung, ex.Message} 'Zeigt ein Fehler-Symbol und mitgegebenen Text an.
        End Try
    End Function
End Class
