﻿Imports globalefunktionen

Partial Class WebParts_Vorgang_HalloWeltTB 'Die Klasse des Webparts muss mit der Angabe in der ".ascx"-Datei übereinstimmen, außerdem Bestimmt der Klassenname ob das Webpart z.B. ein anderes Webpart überschreibt. (Falls z.B. das Webpart "Anschrift.ascx" überschrieben werden soll würde die Klasse "WebParts_Adresse_WPAnschrift" sein)
    Inherits myWebControls.myWebPart

#Region " Seitenspezifisches "

    ''' <summary>
    ''' Hier wird in diesem Beispiel die "Autocomplete-Textbox" geladen
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Protected Sub Page_Load(sender As Object, e As System.EventArgs) Handles Me.Load
        Dim Vorgang As Klassen.clsVorgangClient = TryCast(Me.KlassenObjekt, Klassen.clsVorgangClient)
        Dim Benutzersprache As Klassen.clsSprache

        'Falls die Vorgangssprache "Nothing" ist, wird die aktuelle "GlobaleSpracheID" benutzt:
        If Vorgang.Sprache Is Nothing Then
            Benutzersprache = New Klassen.clsSprache(Session.Item("GlobaleSpracheID"))
            'Die meisten "Autocomplete-Textboxen" benötigen nur einen Parameter, bei mehreren Parametern müssen diese mit "|" getrennt werden:
            matbReferenzAdresse.Parameter = Benutzersprache.ID & "|" & Vorgang.Adresse_ID
        Else
            matbReferenzAdresse.Parameter = Vorgang.Sprache.ID & "|" & Vorgang.Adresse_ID
        End If
    End Sub

#End Region

#Region " Prozeduren "

    ''' <summary>
    ''' Diese Funktion wird benutzt um Daten aus dem aktuellen Klassen-Objekt zu laden.
    ''' </summary>
    ''' <remarks></remarks>
    Protected Overrides Sub LoadDataFromKlassenObjekt()
        'Hier werden nur testweise einige Werte geladen
        Dim Vorgang As Klassen.clsVorgangClient = TryCast(Me.KlassenObjekt, Klassen.clsVorgangClient)

        globalefunktionen.LoadDataFromKlassenObjekt(Vorgang.Bezeichnung, "Text", matbBezeichnung, Session, Request.Url.OriginalString & Me.Title)

        If Vorgang.Termin = Nothing Then
            matbTermin.Text = String.Empty
        Else
            globalefunktionen.LoadDataFromKlassenObjekt(Vorgang.Termin, "Text", matbTermin, Session, Request.Url.OriginalString & Me.Title)
        End If

        globalefunktionen.LoadDataFromKlassenObjekt(Vorgang.Lieferziel, "Text", matbLieferziel, Session, Request.Url.OriginalString & Me.Title)
    End Sub

    ''' <summary>
    ''' Diese Funktion wird benutzt um Daten in das aktuelle Klassen-Objekt zu speichern.
    ''' </summary>
    ''' <remarks></remarks>
    Protected Overrides Sub SaveDataToKlassenObjekt()
        'Hier werden nur testweise einige Werte gespeichert
        Dim Vorgang As Klassen.clsVorgangClient = TryCast(Me.KlassenObjekt, Klassen.clsVorgangClient)

        If Vorgang.Fertiggestellt = False Then 'Nur speichern, wenn der Vorgang nicht Fertiggestellt ist
            globalefunktionen.SaveDataToKlassenObjekt(Vorgang, "Bezeichnung", "matbBezeichnung.Text", matbBezeichnung.Text, Session, Request.Url.OriginalString & Me.Title)

            If Microsoft.VisualBasic.IsDate(matbTermin.Text) Then
                globalefunktionen.SaveDataToKlassenObjekt(Vorgang, "Termin", "matbTermin.Text", matbTermin.Text, Session, Request.Url.OriginalString & Me.Title)
            End If

            globalefunktionen.SaveDataToKlassenObjekt(Vorgang, "Lieferziel", "matbLieferziel.Text", IsDouble(matbLieferziel.Text), Session, Request.Url.OriginalString & Me.Title)
        End If
    End Sub

#End Region

#Region " In diesem Beispiel nicht relevant "

    ''' <summary>
    ''' Hier kann ein Bild angegeben werden, welches im Dialog "Webpart hinzufügen" angezeigt wird
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Overrides Property CatalogIconImageUrl() As String
        Get
            Return ""
        End Get
        Set(ByVal value As String)

        End Set
    End Property

    ''' <summary>
    ''' Hier kann ein Beschreibungstext für das Webpart angegeben werden, welcher im Dialog "Webpart hinzufügen" angezeigt wird
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Overrides Property Description() As String
        Get
            Return "Hier steht die Beschreibung"
        End Get
        Set(ByVal value As String)

        End Set
    End Property

    ''' <summary>
    ''' Wird Nach dem Titel in der Titelzeile und im Dialog "Webpart hinzufügen" angezeigt
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Overrides ReadOnly Property Subtitle() As String
        Get
            Return ""
        End Get
    End Property

    ''' <summary>
    ''' Der Titel des Webparts wird in der Titelzeile, im Dialog "Webpart hinzufügen" und an weiteren Stellen angezeigt angezeigt
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Overrides Property Title() As String
        Get
            Return "Fortgeschritten - 01 MyAJAXTextBox"
        End Get
        Set(ByVal value As String)

        End Set
    End Property

    ''' <summary>
    ''' Hier kann ein Bild angegeben werden, welches in der Titelzeile des Webparts angezeigt wird
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Overrides Property TitleIconImageUrl() As String
        Get
            Return ""
        End Get
        Set(ByVal value As String)

        End Set
    End Property

    ''' <summary>
    ''' Hier kann ein Webadresse angegeben werden, welche die Titelleiste in einen Link umwandelt, diese Funktion wird allerdings bisher nicht verwendet
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Overrides Property TitleUrl() As String
        Get
            Return ""
        End Get
        Set(ByVal value As String)

        End Set
    End Property

    ''' <summary>
    ''' Wenn hier eine Webadresse angegeben wird, erscheint das Hilfe-Symbol in der Titelzeile und leitet den Benutzer, wenn geklickt, auf die jeweilige Webadresse
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Overrides ReadOnly Property HelpUrl() As String
        Get
            Return ""
        End Get
    End Property

    ''' <summary>
    ''' In diesem Beispiel nicht relevant
    ''' </summary>
    ''' <param name="session"></param>
    ''' <remarks></remarks>
    Public Overrides Sub SaveDataToSession(ByVal session As System.Web.SessionState.HttpSessionState)
    End Sub

#End Region

End Class