﻿Imports globalefunktionen

Partial Class WebParts_Optionen_HalloWeltAT 'Die Klasse des Webparts muss mit der Angabe in der ".ascx"-Datei übereinstimmen, außerdem Bestimmt der Klassenname ob das Webpart z.B. ein anderes Webpart überschreibt. (Falls z.B. das Webpart "Anschrift.ascx" überschrieben werden soll würde die Klasse "WebParts_Adresse_WPAnschrift" sein)
    Inherits myWebControls.myWebPart

#Region " Globales "

    ''' <summary>
    ''' Der Inhalt der speziellen Einstellungen kann manuell festgelegt werden, da der Inhalt jedoch serialisiert wird muss darauf geachtet werden, dass nicht alle Datentypen benutzt werden könnnen
    ''' </summary>
    ''' <remarks></remarks>
    <Serializable()> _
    Public Class sRoutinenParameter
        Public Teststring As String
    End Class

#End Region

#Region " Seitenspezifisches "

    Protected Sub Page_Load(sender As Object, e As System.EventArgs) Handles Me.Load
        If Me.Page.IsPostBack = False Then
            LoadSettings()
        End If
    End Sub

    ''' <summary>
    ''' "Button" um eine manuelle Prüfung auszulösen
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Protected Sub mbJetztPruefen_Click(sender As Object, e As System.EventArgs) Handles mbJetztPruefen.Click
        SaveSettings()
        AutomatischeRoutineAusfuehren(Me.WebPartID)
    End Sub

#End Region

#Region " Prozeduren "

    Protected Overrides Sub SaveDataToKlassenObjekt()
        SaveSettings()
    End Sub

    Private Sub LoadSettings()
        Dim WP As New Klassen.clsWebPart(Me.WebPartID)
        Dim tmpObj As Object
        Dim RoutinenParameter As sRoutinenParameter '                                                   Der Inhalt der speziellen Einstellungen kann manuell festgelegt werden, da der Inhalt jedoch serialisiert wird muss darauf geachtet werden, dass nicht alle Datentypen benutzt werden könnnen
        tmpObj = WP.AutomatischeRoutineEinstellungenSpeziell(GetType(sRoutinenParameter)) '             Über das Aktuelle Webpart können die speziellen(eigenen) Einstellungen ausgelesen werden

        If Not tmpObj Is Nothing Then
            RoutinenParameter = tmpObj

            matbTeststring.Text = RoutinenParameter.Teststring
        End If
    End Sub

    Private Sub SaveSettings()
        Dim WP As New Klassen.clsWebPart(Me.WebPartID)
        Dim tmpObj As Object
        Dim RoutinenParameter As sRoutinenParameter '                                                   Der Inhalt der speziellen Einstellungen kann manuell festgelegt werden, da der Inhalt jedoch serialisiert wird muss darauf geachtet werden, dass nicht alle Datentypen benutzt werden könnnen
        tmpObj = WP.AutomatischeRoutineEinstellungenSpeziell(GetType(sRoutinenParameter)) '             Über das Aktuelle Webpart können die speziellen(eigenen) Einstellungen ausgelesen werden

        If Not tmpObj Is Nothing Then
            RoutinenParameter = tmpObj
        Else
            RoutinenParameter = New sRoutinenParameter
        End If

        RoutinenParameter.Teststring = matbTeststring.Text

        WP.AutomatischeRoutineEinstellungenSpeziell(GetType(sRoutinenParameter)) = RoutinenParameter '  Die Änderungen werden wieder  zurück an das Webpart geschrieben/gespeichert
    End Sub

#End Region

#Region " Funktionen "

    ''' <summary>
    ''' Achtung! Diese Routine wird je nach Einstellungen von UniERM automatisch aufgerufen und kann deshalb NICHT(!) auf Steuerelemente oder Werte außerhalb dieser Funktion zugreifen
    ''' </summary>
    ''' <param name="WebpartID"></param>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Overrides Function AutomatischeRoutineAusfuehren(ByVal WebpartID As Integer) As Boolean
        Dim wp As New Klassen.clsWebPart(WebpartID)
        Dim tmpObj As Object
        Dim RoutinenParameter As sRoutinenParameter

        Dim tmpMeldung As Klassen.clsMeldung
        Dim tmpAdresse As Klassen.clsAdresse

        tmpObj = wp.AutomatischeRoutineEinstellungenSpeziell(GetType(sRoutinenParameter)) '              Über das Webpart können die speziellen(eigenen) Einstellungen ausgelesen werden

        If Not tmpObj Is Nothing Then
            RoutinenParameter = tmpObj

            If RoutinenParameter.Teststring = "" Then '     So können Fehler in der Routine geloggt werden: (in diesem Fall landet der Fehler in der Datei: "UniERM-Client\Logs\clientlog\*Jahr*_*Monat*_log.txt")
                Klassen.clsFunktionen.Log("AutomatischeRoutine Test: " & "Fehler, kein Teststring definiert!", Klassen.clsFunktionen.eLogart.clientlog)
                Return False
            End If

            tmpAdresse = New Klassen.clsAdresse(1) '        Hier wird einfach die erste Adresse instanziert, da dies die Administrator/Firmenadresse ist
            If Not tmpAdresse Is Nothing Then
                tmpMeldung = New Klassen.clsMeldung '       Eine neue Meldung wird erstellt, mit Daten gefüllt und der Adresse zugeswiesen:
                tmpMeldung.Text = "<b>Hey!</b><br /><br />" & RoutinenParameter.Teststring & "<br />" 'Der Inhalt, hier kann HTML verwendet werden.
                tmpMeldung.Flag_IstPrivat = True '          Bestimmt aktuell nur die Farbe der Meldung (False = Rot Allgemeine Meldung, True = Grün "persönliche" Meldung) später soll dieses Flag zusätzlich bestimmen wer die Meldung bearbeiten kann.
                tmpMeldung.GueltigAb = Now '                Die Meldung ist sofort gültig / wird sofort angezeigt
                tmpMeldung.GueltigBis = Now.AddDays(1) '    Die Meldung ist 1 Tag gültig (Falls die Meldung 1 Tag nicht angesehen wird, verfällt sie)

                tmpAdresse.Meldungen.Add(tmpMeldung) '      Meldung der Adresse hinzufügen (Hier können auch mehrere Adressen zugewiesen werden)
            End If

            'ACHTUNG! Es kann bis zu 20 Sekunden dauern bis die Meldung angezeigt wird, da in diesem Intervall nach neuen Meldungen gesucht wird.
        End If
        Return True
    End Function

#End Region

#Region " In diesem Beispiel nicht relevant "

    ''' <summary>
    ''' Diese Funktion wird benutzt um Daten aus dem aktuellen Klassen-Objekt zu laden.
    ''' </summary>
    ''' <remarks></remarks>
    Protected Overrides Sub LoadDataFromKlassenObjekt()
    End Sub

    ''' <summary>
    ''' Hier kann ein Bild angegeben werden, welches im Dialog "Webpart hinzufügen" angezeigt wird
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Overrides Property CatalogIconImageUrl() As String
        Get
            Return ""
        End Get
        Set(ByVal value As String)

        End Set
    End Property

    ''' <summary>
    ''' Hier kann ein Beschreibungstext für das Webpart angegeben werden, welcher im Dialog "Webpart hinzufügen" angezeigt wird
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Overrides Property Description() As String
        Get
            Return "Hier steht die Beschreibung"
        End Get
        Set(ByVal value As String)

        End Set
    End Property

    ''' <summary>
    ''' Wird Nach dem Titel in der Titelzeile und im Dialog "Webpart hinzufügen" angezeigt
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Overrides ReadOnly Property Subtitle() As String
        Get
            Return ""
        End Get
    End Property

    ''' <summary>
    ''' Der Titel des Webparts wird in der Titelzeile, im Dialog "Webpart hinzufügen" und an weiteren Stellen angezeigt angezeigt
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Overrides Property Title() As String
        Get
            Return "Fortgeschritten - 02 Automatische Routine und Meldung"
        End Get
        Set(ByVal value As String)

        End Set
    End Property

    ''' <summary>
    ''' Hier kann ein Bild angegeben werden, welches in der Titelzeile des Webparts angezeigt wird
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Overrides Property TitleIconImageUrl() As String
        Get
            Return ""
        End Get
        Set(ByVal value As String)

        End Set
    End Property

    ''' <summary>
    ''' Hier kann ein Webadresse angegeben werden, welche die Titelleiste in einen Link umwandelt, diese Funktion wird allerdings bisher nicht verwendet
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Overrides Property TitleUrl() As String
        Get
            Return ""
        End Get
        Set(ByVal value As String)

        End Set
    End Property

    ''' <summary>
    ''' Wenn hier eine Webadresse angegeben wird, erscheint das Hilfe-Symbol in der Titelzeile und leitet den Benutzer, wenn geklickt, auf die jeweilige Webadresse
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Overrides ReadOnly Property HelpUrl() As String
        Get
            Return ""
        End Get
    End Property

    ''' <summary>
    ''' In diesem Beispiel nicht relevant
    ''' </summary>
    ''' <param name="session"></param>
    ''' <remarks></remarks>
    Public Overrides Sub SaveDataToSession(ByVal session As System.Web.SessionState.HttpSessionState)
    End Sub

#End Region

End Class