﻿Imports globalefunktionen

Partial Class WebParts_Adresse_HalloWeltSonst 'Die Klasse des Webparts muss mit der Angabe in der ".ascx"-Datei übereinstimmen, außerdem Bestimmt der Klassenname ob das Webpart z.B. ein anderes Webpart überschreibt. (Falls z.B. das Webpart "Anschrift.ascx" überschrieben werden soll würde die Klasse "WebParts_Adresse_WPAnschrift" sein)
    Inherits myWebControls.myWebPart

    Private Const AnredePopup As String = "Neue Anrede:" 'Die Überschrift des Popups wird benutzt um festzustellen welches Popup ein bestimmtes "Event" gesendet hat
    Private WithEvents mampFehler As myWebControls.myAJAXModalPopUp

#Region " Seitenspezifisches "

    ''' <summary>
    ''' Hier wird in diesem Beispiel die "Autocomplete-Textbox" geladen
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Protected Sub Page_Load(sender As Object, e As System.EventArgs) Handles Me.Load
        Dim adresse As Klassen.clsAdresse = TryCast(Me.KlassenObjekt, Klassen.clsAdresse)

        'Anrede & Briefanrede Parameter anpassen
        odsAnrede.SelectParameters("param1").DefaultValue = adresse.BasisSprache.ID

        If mampFehler Is Nothing Then
            mampFehler = DirectCast(Page.Master.FindControl("mampInfoBox"), myWebControls.myAJAXModalPopUp)
        End If
    End Sub

    Protected Sub macbAnrede_DataBound(ByVal sender As Object, ByVal e As System.EventArgs) Handles macbAnrede.DataBound
        macbAnrede.Items.Insert(0, String.Empty)
    End Sub

    Protected Sub lbNeueAnrede_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles lbNeueAnrede.Click
        mampNeueTB.Caption = AnredePopup
        mampNeueTB.Parameter = New Object() {Nothing, False} 'Label Sichtbarkeit
        mampNeueTB.Show()
    End Sub

    Protected Sub maefNeueTB_Ok(ByVal sender As Object, ByVal e As System.EventArgs) Handles mampNeueTB.Ok
        Dim adresse As Klassen.clsAdresse
        Dim anrede As Klassen.clsAnrede

        If mampNeueTB.Response Is Nothing OrElse mampNeueTB.Response.Length < 1 OrElse mampNeueTB.Response(0).ToString.Trim = String.Empty Then
            mampNeueTB.Parameter = New Object() {"Geben Sie bitte eine Bezeichnung an oder klicken Sie auf Abbrechen.", True}
            mampNeueTB.Show()
        Else

            adresse = TryCast(Me.KlassenObjekt, Klassen.clsAdresse)

            If adresse Is Nothing Then
                mampFehler.Caption = "Fehler!"
                mampFehler.Parameter = New Object() {"Bitte speichern Sie zunächst diese Adresse!"}
                mampFehler.Show()
            Else
                If mampNeueTB.Caption = AnredePopup Then
                    anrede = New Klassen.clsAnrede()
                    anrede.BasisSprache = adresse.BasisSprache
                    anrede.Bezeichnung = mampNeueTB.Response(0).ToString

                    '"ComboBox" erneut laden
                    macbAnrede.Items.Clear()
                    macbAnrede.DataBind()

                    If macbAnrede.Enabled AndAlso macbAnrede.ReadOnly = False Then
                        macbAnrede.SelectedValue = anrede.ID
                    End If
                End If
            End If
        End If
    End Sub

    Protected Sub mcbIstFirma_CheckedChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles mcbIstFirma.CheckedChanged
        If mcbIstFirma.Checked Then
            'Hier könnte Ihr Quellcode stehen
        End If
    End Sub

#End Region

#Region " Prozeduren "

    ''' <summary>
    ''' Diese Funktion wird benutzt um Daten aus dem aktuellen Klassen-Objekt zu laden.
    ''' </summary>
    ''' <remarks></remarks>
    Protected Overrides Sub LoadDataFromKlassenObjekt()
        'Hier werden nur testweise einige Werte geladen
        Dim adresse As Klassen.clsAdresse = TryCast(Me.KlassenObjekt, Klassen.clsAdresse)

        If Not adresse.Benutzersprache Is Nothing Then
            globalefunktionen.LoadDataFromKlassenObjekt(adresse.Benutzersprache.ID, "SelectedValue", macbBenutzersprache, Session, Request.Url.OriginalString & Me.Title)
        End If

        globalefunktionen.LoadDataFromKlassenObjekt(adresse.Flag_IstFirma, "Checked", mcbIstFirma, Session, Request.Url.OriginalString & Me.Title)
        mcbIstFirma_CheckedChanged(Nothing, Nothing)

        If Not adresse.StandardAnrede Is Nothing Then
            globalefunktionen.LoadDataFromKlassenObjekt(adresse.StandardAnrede.ID, "SelectedValue", macbAnrede, Session, Request.Url.OriginalString & Me.Title)
        End If
    End Sub

    ''' <summary>
    ''' Diese Funktion wird benutzt um Daten in das aktuelle Klassen-Objekt zu speichern.
    ''' </summary>
    ''' <remarks></remarks>
    Protected Overrides Sub SaveDataToKlassenObjekt()
        'Hier werden nur testweise einige Werte gespeichert
        Dim adresse As Klassen.clsAdresse = TryCast(Me.KlassenObjekt, Klassen.clsAdresse)

        If Not macbBenutzersprache.SelectedValue.Trim = String.Empty Then
            globalefunktionen.SaveDataToKlassenObjekt(adresse, "Benutzersprache", "macbBenutzersprache.SelectedValue", macbBenutzersprache.SelectedValue, New Klassen.clsSprache(CInt(macbBenutzersprache.SelectedValue)), Session, Request.Url.OriginalString & Me.Title)
        Else
            globalefunktionen.SaveDataToKlassenObjekt(adresse, "Benutzersprache", "macbBenutzersprache.SelectedValue", Nothing, Session, Request.Url.OriginalString & Me.Title)
        End If

        globalefunktionen.SaveDataToKlassenObjekt(adresse, "Flag_IstFirma", "mcbIstFirma.Checked", mcbIstFirma.Checked, Session, Request.Url.OriginalString & Me.Title)

        If Not macbAnrede.SelectedValue.Trim = String.Empty Then
            globalefunktionen.SaveDataToKlassenObjekt(adresse, "StandardAnrede", "macbAnrede.SelectedValue", macbAnrede.SelectedValue, New Klassen.clsAnrede(CInt(macbAnrede.SelectedValue)), Session, Request.Url.OriginalString & Me.Title)
        Else
            globalefunktionen.SaveDataToKlassenObjekt(adresse, "StandardAnrede", "macbAnrede.SelectedValue", Nothing, Session, Request.Url.OriginalString & Me.Title)
        End If
    End Sub

#End Region

#Region " In diesem Beispiel nicht relevant "

    ''' <summary>
    ''' Hier kann ein Bild angegeben werden, welches im Dialog "Webpart hinzufügen" angezeigt wird
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Overrides Property CatalogIconImageUrl() As String
        Get
            Return ""
        End Get
        Set(ByVal value As String)

        End Set
    End Property

    ''' <summary>
    ''' Hier kann ein Beschreibungstext für das Webpart angegeben werden, welcher im Dialog "Webpart hinzufügen" angezeigt wird
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Overrides Property Description() As String
        Get
            Return "Hier steht die Beschreibung"
        End Get
        Set(ByVal value As String)

        End Set
    End Property

    ''' <summary>
    ''' Wird Nach dem Titel in der Titelzeile und im Dialog "Webpart hinzufügen" angezeigt
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Overrides ReadOnly Property Subtitle() As String
        Get
            Return ""
        End Get
    End Property

    ''' <summary>
    ''' Der Titel des Webparts wird in der Titelzeile, im Dialog "Webpart hinzufügen" und an weiteren Stellen angezeigt angezeigt
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Overrides Property Title() As String
        Get
            Return "Fortgeschritten - 03 Weitere Steuerlemente"
        End Get
        Set(ByVal value As String)

        End Set
    End Property

    ''' <summary>
    ''' Hier kann ein Bild angegeben werden, welches in der Titelzeile des Webparts angezeigt wird
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Overrides Property TitleIconImageUrl() As String
        Get
            Return ""
        End Get
        Set(ByVal value As String)

        End Set
    End Property

    ''' <summary>
    ''' Hier kann ein Webadresse angegeben werden, welche die Titelleiste in einen Link umwandelt, diese Funktion wird allerdings bisher nicht verwendet
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Overrides Property TitleUrl() As String
        Get
            Return ""
        End Get
        Set(ByVal value As String)

        End Set
    End Property

    ''' <summary>
    ''' Wenn hier eine Webadresse angegeben wird, erscheint das Hilfe-Symbol in der Titelzeile und leitet den Benutzer, wenn geklickt, auf die jeweilige Webadresse
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Overrides ReadOnly Property HelpUrl() As String
        Get
            Return ""
        End Get
    End Property

    ''' <summary>
    ''' In diesem Beispiel nicht relevant
    ''' </summary>
    ''' <param name="session"></param>
    ''' <remarks></remarks>
    Public Overrides Sub SaveDataToSession(ByVal session As System.Web.SessionState.HttpSessionState)
    End Sub

#End Region

End Class