﻿Partial Class WebParts_Adresse_HalloWeltGridview 'Die Klasse des Webparts muss mit der Angabe in der ".ascx"-Datei übereinstimmen, außerdem bestimmt der Klassenname ob das Webpart z.B. ein anderes Webpart überschreibt. (Falls z.B. das Webpart "Anschrift.ascx" überschrieben werden soll würde die Klasse "WebParts_Adresse_WPAnschrift" sein)
    Inherits myWebControls.myWebPart

#Region " Prozeduren "

    ''' <summary>
    ''' Über diese Funktion werden die relevanten Zustandsdaten des Gridviews in die Session gespeichert. Wird das Gridview (z.B. nach einem Tabwechsel) wieder aufgerufen, so werden diese Daten aus der Session geladen. Dadurch bleibt z.B. die Sortierung, etc. auch zwischen Tabwechseln erhalten. 
    ''' </summary>
    ''' <param name="session"></param>
    ''' <remarks></remarks>
    Public Overrides Sub SaveDataToSession(ByVal session As System.Web.SessionState.HttpSessionState)
        MyBase.SaveControlPropertyToSession(mgvAnsprechpartner, "PageIndex", session) 'speichert, auf welcher Page des Gridviews der Benutzer als letztes war.
        MyBase.SaveControlPropertyToSession(mgvAnsprechpartner, "SortDirection", session) 'speichert, welche Sortierrichtung als letztes ausgewählt war (ASC oder DESC).
        MyBase.SaveControlPropertyToSession(mgvAnsprechpartner, "SortExpression", session) 'speichert, nach welcher Spalte das Gridview als letztes sortiert war.
        MyBase.SaveControlPropertyToSession(mgvAnsprechpartner, "EditIndex", session) 'speichert, welche Zeile des Gridviews als letztes editiert wurde. Wurde keine editiert ist der Index bei -1. 
    End Sub

#Region " Seitenspezifisch "

    ''' <summary>
    ''' Dieses Event wird aufgerufen, wenn einer der Buttons in der Spalte Aktionen geklickt wird. 
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Protected Sub mgvAnsprechpartner_RowCommand(ByVal sender As Object, ByVal e As System.Web.UI.WebControls.GridViewCommandEventArgs) Handles mgvAnsprechpartner.RowCommand
        Dim Ansprechpartner As Klassen.clsAdresse 'Ansprechpartner werden in UniERM als Adresse geführt. Dementsprechend wird hier die Variable Ansprechpartner vom Typ Klassen.clsAdresse deklariert. 

        'Auslesen welcher Button geklickt wurde. 
        Select Case e.CommandName
            Case "lbNeu" 'Wenn der Neu-Button geklickt wurde, wird mit den Daten im Footer des Gridviews ein neuer Ansprechpartner angelegt. 
                AnsprechpartnerAnlegen()
            Case "lbSpeichern" 'Wenn der Speichern-Button geklickt wurde, wird der Ansprechpartner aufgrund der Datenbank-ID, die in der Gridview-Zeile gespeichert wurde, instanziert und die Daten aus der Zeile, die editiert wird, in diesen Adressdatensatz übernommen. 
                Ansprechpartner = New Klassen.clsAdresse(CInt(mgvAnsprechpartner.DataKeys(mgvAnsprechpartner.EditIndex).Value)) 'Auslesen des Primary-Keys der Gridview-Zeile und instanzieren des Ansprechpartners.
                AnsprechpartnerSpeichern(Ansprechpartner)
            Case "lbLoeschen" 'Wenn der Löschen-Button geklickt wurde, wird der Ansprechpartner gelöscht.
                Ansprechpartner = New Klassen.clsAdresse(CInt(mgvAnsprechpartner.DataKeys(e.CommandArgument).Value)) 'Mit dem Primary-Key der Gridview-Zeile, die das Event aufgerufen hat, wird der Ansprechpartner instanziert.
                Ansprechpartner.Loeschen()
                mgvAnsprechpartner.DataBind()
            Case "lbAdresseOeffnen" 'Wenn der Öffnen-Button geklickt wird, wird der Ansprechpartner in einem neuen Tab geöffnet.
                Response.Redirect("~/Adresse.aspx?ID=" & mgvAnsprechpartner.DataKeys(e.CommandArgument).Value) 'Der Aufruf der Adressenseite mit der entsprechenden ID öffnet den Ansprechpartner automatisch als neues Tab. 
        End Select
    End Sub

    ''' <summary>
    ''' Funktion, um mit den Daten aus dem Footer des Gridviews einen neuen Ansprechpartner für diese Adresse anzulegen.
    ''' </summary>
    ''' <remarks></remarks>
    Public Sub AnsprechpartnerAnlegen()
        'Deklaration der Steuerelemente, die vom Footer instanziert werden müssen.
        Dim mcbPost As myWebControls.myCheckbox
        Dim macbAnrede As myWebControls.myAJAXComboBox
        Dim matbName1 As myWebControls.myAJAXTextBox

        'Deklaration der benötigten UniERM-Variabeln.
        Dim Ansprechpartner As Klassen.clsAdresse
        Dim Adresse As Klassen.clsAdresse
        Dim Anrede As Klassen.clsAnrede

        'Casten der Steuerelement aufgrund der Footerrow in dem entsprechenden Datentyp des gecasteten Controls. 
        mcbPost = DirectCast(mgvAnsprechpartner.FooterRow.FindControl("mcbPost"), myWebControls.myCheckbox)
        macbAnrede = DirectCast(mgvAnsprechpartner.FooterRow.FindControl("macbAnrede"), myWebControls.myAJAXComboBox)
        matbName1 = DirectCast(mgvAnsprechpartner.FooterRow.FindControl("matbName1"), myWebControls.myAJAXTextBox)

        Ansprechpartner = New Klassen.clsAdresse() 'Durch das Instanzieren des neuen Ansprechpartner wird der neue Datensatz in der Datenbank angelegt.
        Ansprechpartner.Flag_IstAnsprechpartner = True 'Die Adresse wird als Ansprechpartner markiert. Die Änderung wird direkt in der Datenbank gespeichert. 
        Adresse = TryCast(MyBase.KlassenObjekt, Klassen.clsAdresse) 'Instanzieren der geöffneten Adresse, zu der der neue Ansprechpartner gespeichert werden soll. 

        'Wenn in der Dropdown eine Anrede ausgewählt wurde, wird diese ebenfalls instanziert und als Standardanrede für den Ansprechpartner zugewiesen. 
        If Not macbAnrede.SelectedValue = "" Then
            Anrede = New Klassen.clsAnrede(macbAnrede.SelectedValue) 'Instanzieren der Anrede. Im SelectedValue der Dropdown wird die Datenbank-ID der Anrede gespeichert.
            Ansprechpartner.StandardAnrede = Anrede 'Zuweisen der Anrede als Standardarede zu dem neuen Ansprechpartner. Die Änderung wird direkt in der Datenbank gespeichert. (Spalte StandardAnredeID in der Tabelle Adresse)
        End If

        'Speichern der restlichen Werte. Die Werte werden direkt in die Datenbank übertragen. 
        Ansprechpartner.Name1 = matbName1.Text
        Ansprechpartner.Post = mcbPost.Checked

        'Als letztes wird der Ansprechpartner der geöffneten Adresse als neuer Ansprechpartner zugewiesen. 
        Adresse.Ansprechpartner.Add(Ansprechpartner)

        'Damit die Datenbankänderungen alle in dem aktuellen Gridview direkt sichtbar werden, wird das Gridview neu an die Datenquelle gebunden, was dazu führt, dass auch alle Änderungen neu geladen werden.
        mgvAnsprechpartner.DataBind()
    End Sub

    ''' <summary>
    ''' Diese Funktion speichert die Daten aus der editierten Zeile in den übergebenen Ansprechpartner. 
    ''' </summary>
    ''' <param name="Ansprechpartner"></param>
    ''' <remarks></remarks>
    Public Sub AnsprechpartnerSpeichern(ByVal Ansprechpartner As Klassen.clsAdresse)
        'Deklaration der Steuerelemente, die vom Footer instanziert werden müssen.
        Dim mcbPost As myWebControls.myCheckbox
        Dim macbAnrede As myWebControls.myAJAXComboBox
        Dim matbName1 As myWebControls.myAJAXTextBox

        'Deklaration der benötigten UniERM-Variabeln.
        Dim Anrede As Klassen.clsAnrede

        'Casten der Steuerelement aufgrund der editierten Zeile in dem entsprechenden Datentyp des gecasteten Controls. Dafür wird der Editindex des Gridviews genutzt. 
        mcbPost = DirectCast(mgvAnsprechpartner.Rows(mgvAnsprechpartner.EditIndex).FindControl("mcbPost"), myWebControls.myCheckbox)
        macbAnrede = DirectCast(mgvAnsprechpartner.Rows(mgvAnsprechpartner.EditIndex).FindControl("macbAnrede"), myWebControls.myAJAXComboBox)
        matbName1 = DirectCast(mgvAnsprechpartner.Rows(mgvAnsprechpartner.EditIndex).FindControl("matbName1"), myWebControls.myAJAXTextBox)

        'Wenn in der Dropdown eine Anrede ausgewählt wurde, wird diese ebenfalls instanziert und als Standardanrede für den Ansprechpartner zugewiesen. 
        If Not macbAnrede.SelectedValue = "" Then
            Anrede = New Klassen.clsAnrede(macbAnrede.SelectedValue)
            Ansprechpartner.StandardAnrede = Anrede
        Else
            Ansprechpartner.StandardAnrede = Nothing
        End If

        'Speichern der restlichen Werte. Die Werte werden direkt in die Datenbank übertragen. 
        Ansprechpartner.Post = mcbPost.Checked
        Ansprechpartner.Name1 = matbName1.Text

        'Zurücksetzen des Editindexes, damit die Zeile nicht mehr im Editiermodus ist. 
        mgvAnsprechpartner.EditIndex = -1

        'Damit die Datenbankänderungen alle in dem aktuellen Gridview direkt sichtbar werden, wird das Gridview neu an die Datenquelle gebunden, was dazu führt, dass auch alle Änderungen neu geladen werden.
        mgvAnsprechpartner.DataBind()
    End Sub

#End Region

#End Region

#Region "In diesem Beispiel nicht relevant."

#Region " Eigenschaften "

    ''' <summary>
    ''' Hier kann ein Bild angegeben werden, welches im Dialog "Webpart hinzufügen" angezeigt wird
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Overrides Property CatalogIconImageUrl() As String
        Get
            Return ""
        End Get
        Set(ByVal value As String)

        End Set
    End Property

    ''' <summary>
    ''' Hier kann ein Beschreibungstext für das Webpart angegeben werden, welcher im Dialog "Webpart hinzufügen" angezeigt wird
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Overrides Property Description() As String
        Get
            Return "Hier steht die Beschreibung"
        End Get
        Set(ByVal value As String)

        End Set
    End Property

    ''' <summary>
    ''' Wird Nach dem Titel in der Titelzeile und im Dialog "Webpart hinzufügen" angezeigt
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Overrides ReadOnly Property Subtitle() As String
        Get
            Return ""
        End Get
    End Property

    ''' <summary>
    ''' Der Titel des Webparts wird in der Titelzeile, im Dialog "Webpart hinzufügen" und an weiteren Stellen angezeigt angezeigt
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Overrides Property Title() As String
        Get
            Return "Fortgeschritten - 04 myGridview"
        End Get
        Set(ByVal value As String)

        End Set
    End Property

    ''' <summary>
    ''' Hier kann ein Bild angegeben werden, welches in der Titelzeile des Webparts angezeigt wird
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Overrides Property TitleIconImageUrl() As String
        Get
            Return ""
        End Get
        Set(ByVal value As String)

        End Set
    End Property

    ''' <summary>
    ''' Hier kann ein Webadresse angegeben werden, welche die Titelleiste in einen Link umwandelt, diese Funktion wird allerdings bisher nicht verwendet
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Overrides Property TitleUrl() As String
        Get
            Return ""
        End Get
        Set(ByVal value As String)

        End Set
    End Property

    ''' <summary>
    ''' Wenn hier eine Webadresse angegeben wird, erscheint das Hilfe-Symbol in der Titelzeile und leitet den Benutzer, wenn geklickt, auf die jeweilige Webadresse
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Overrides ReadOnly Property HelpUrl() As String
        Get
            Return ""
        End Get
    End Property

#End Region

#Region " Prozeduren "

    ''' <summary>
    ''' In diesem Beispiel nicht relevant.
    ''' </summary>
    ''' <remarks></remarks>
    Protected Overrides Sub LoadDataFromKlassenObjekt()

    End Sub

    ''' <summary>
    ''' In diesem Beispiel nicht relevant.
    ''' </summary>
    ''' <remarks></remarks>
    Protected Overrides Sub SaveDataToKlassenObjekt()

    End Sub

#End Region

#End Region

End Class