﻿Imports globalefunktionen

Partial Class WebParts_Vorgang_HalloWeltTreeView 'Die Klasse des Webparts muss mit der Angabe in der ".ascx"-Datei übereinstimmen, außerdem Bestimmt der Klassenname ob das Webpart z.B. ein anderes Webpart überschreibt. (Falls z.B. das Webpart "Anschrift.ascx" überschrieben werden soll würde die Klasse "WebParts_Adresse_WPAnschrift" sein)
    Inherits myWebControls.myWebPart

#Region " Seitenspezifisches "

    Protected Sub Page_Init(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Init
        If JQueryTreeview.Initialized = False Then '                                                    Der Wert "Initialized" wird benutzt um zu speichern ob der Treeview bereits initial geladen wurde, er wird zum Ende der Prozedur "TreeviewLaden" manuell gesetzt.
            JQueryTreeview.Reset() '                                                                    Dies setzt alle Werte des Treeviews auf die Standardwerte
            TreeviewLaden() '                                                                           Diese Prozedur wird im aktuellen Beispiel benutzt um den Treeview zu initialisieren
        End If
    End Sub

#End Region

#Region " Prozeduren "

    Private Sub TreeviewLaden()
        InhaltHauptTreeviewLaden() '                                                                    Diese Prozedur wird im aktuellen Beispiel benutzt um den Treeview zu füllen

        JQueryTreeview.Editmode = False '                                                               "Treeview-Nodes" können nicht verschoben werden (Dies kann auch nur für bestimmte "Nodes" aktiviert werden, mehr dazu in den weiteren "Treeeview-Beispielen")
        JQueryTreeview.DisableDrops = True '                                                            Der Treeview aktzeptiert keine "Nodes"
        JQueryTreeview.InsertSpacerNode = True '                                                        Wenn der Treeview keine "Nodes" aktzeptiert rücken die vorhandenen "Nodes" dichter zusammen, falls dies nicht gewünscht ist kann diese Eigenschaft aktiviert werden
        JQueryTreeview.SaveTrunkToSession() '                                                           Speichert den aktuellen Zustand in die Session
        JQueryTreeview.Initialized = True '                                                             Setzt den Wert "Initialized", so dass der Treeview nicht erneut gefüllt wird
    End Sub

    Private Sub InhaltHauptTreeviewLaden()
        Dim parentnode As JQueryTreeview.myTreeNode

        parentnode = New JQueryTreeview.myTreeNode("Positionen") '                                      Die erste übergeordnete "Node" unter der die Positionen eingefügt werden
        PositionenLaden(parentnode) '                                                                   Diese Funktion nimmt eine "Node" entgegen und hängt an diese die Positionen
        JQueryTreeview.TreeTrunk.addTreeNode(parentnode) '                                              Fügt die "Node" dem Treeview auf der ersten Ebene (im Stamm) hinzu

        parentnode = New JQueryTreeview.myTreeNode("Kundenadresse") '                                   Die zweite übergeordnete "Node" unter der die Kundenadresse eingefügt wird
        AdresseLaden(parentnode)    '                                                                   Diese Funktion nimmt eine "Node" entgegen und hängt an diese die Kundenadresse
        JQueryTreeview.TreeTrunk.addTreeNode(parentnode) '                                              Fügt die "Node" dem Treeview auf der ersten Ebene (im Stamm) hinzu
    End Sub

    Private Sub PositionenLaden(ByVal parentnode As JQueryTreeview.myTreeNode)
        Dim Table As Data.DataTable
        Dim Vorgang As Klassen.clsVorgangClient = TryCast(Me.KlassenObjekt, Klassen.clsVorgangClient)
        Dim VorgangsPosition As Klassen.clsVorgangsPositionClient
        Dim Artikel As Klassen.clsArtikel
        Dim tmpnode As JQueryTreeview.myTreeNode

        'Die Positionen aus der Datenbank auslesen:
        Table = Klassen.clsFunktionen.GetList(New Data.SqlClient.SqlCommand("SELECT ID, Artikel_ID, Artikelmenge FROM VorgangsPositionClient WHERE NOT Artikel_ID IS NULL AND VorgangClientID = " & Vorgang.ID & " ORDER BY Position ASC"))
        If Table IsNot Nothing AndAlso Table.Rows.Count > 0 Then
            For Each Row As Data.DataRow In Table.Rows
                VorgangsPosition = New Klassen.clsVorgangsPositionClient(CInt(Row.Item("ID")))
                Artikel = New Klassen.clsArtikel(CInt(Row.Item("Artikel_ID")))

                If Not Row.Item("Artikelmenge") Is System.DBNull.Value Then
                    'Erstellt eine neue "Node" mit dem Artikelnamen und der Artikelmenge als Text, für die "CustomID" wird die ID der Position gesetzt, die "CustomID" hat für den Treeview selbst keine Funktion und wird wie der "CustomType" nur zum speichern von Informationen bereitgestellt (z.B. um herauszufinden welche "Node" verschoben oder angeklickt wurde) 
                    tmpnode = New JQueryTreeview.myTreeNode(Artikel.Kurztext & " Menge: " & Row.Item("Artikelmenge").ToString)
                Else
                    tmpnode = New JQueryTreeview.myTreeNode(Artikel.Kurztext & " Menge: - ")
                End If

                'Fügt die "Node" der Parentnode hinzu:
                parentnode.addTreeNode(tmpnode)
            Next
        End If
    End Sub

    Private Sub AdresseLaden(ByVal parentnode As JQueryTreeview.myTreeNode)
        Dim Vorgang As Klassen.clsVorgangClient = TryCast(Me.KlassenObjekt, Klassen.clsVorgangClient)
        Dim Adresse As Klassen.clsAdresse
        Dim tmpnode As JQueryTreeview.myTreeNode

        If Not Vorgang.Adresse_ID = 0 Then
            Adresse = New Klassen.clsAdresse(Vorgang.Adresse_ID)
            'Erstellt eine neue "Node" mit dem Namen der Adresse als Text
            tmpnode = New JQueryTreeview.myTreeNode(Adresse.Name1 & " " & Adresse.Name2)
            'Setzt das "Icon", welches vor der "Node" eingeblendet wird:
            tmpnode.IconImage = "App_Themes/Main/Bilder/JQueryTreeview/Report.png"

            'Fügt die "Node" der Parentnode hinzu:
            parentnode.addTreeNode(tmpnode)
        End If
    End Sub

#End Region

#Region " In diesem Beispiel nicht relevant "

    ''' <summary>
    ''' Hier kann ein Bild angegeben werden, welches im Dialog "Webpart hinzufügen" angezeigt wird
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Overrides Property CatalogIconImageUrl() As String
        Get
            Return ""
        End Get
        Set(ByVal value As String)

        End Set
    End Property

    ''' <summary>
    ''' Hier kann ein Beschreibungstext für das Webpart angegeben werden, welcher im Dialog "Webpart hinzufügen" angezeigt wird
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Overrides Property Description() As String
        Get
            Return "Hier steht die Beschreibung"
        End Get
        Set(ByVal value As String)

        End Set
    End Property

    ''' <summary>
    ''' Wird Nach dem Titel in der Titelzeile und im Dialog "Webpart hinzufügen" angezeigt
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Overrides ReadOnly Property Subtitle() As String
        Get
            Return ""
        End Get
    End Property

    ''' <summary>
    ''' Der Titel des Webparts wird in der Titelzeile, im Dialog "Webpart hinzufügen" und an weiteren Stellen angezeigt angezeigt
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Overrides Property Title() As String
        Get
            Return "Fortgeschritten - 05 JQueryTreeview"
        End Get
        Set(ByVal value As String)

        End Set
    End Property

    ''' <summary>
    ''' Hier kann ein Bild angegeben werden, welches in der Titelzeile des Webparts angezeigt wird
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Overrides Property TitleIconImageUrl() As String
        Get
            Return ""
        End Get
        Set(ByVal value As String)

        End Set
    End Property

    ''' <summary>
    ''' Hier kann ein Webadresse angegeben werden, welche die Titelleiste in einen Link umwandelt, diese Funktion wird allerdings bisher nicht verwendet
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Overrides Property TitleUrl() As String
        Get
            Return ""
        End Get
        Set(ByVal value As String)

        End Set
    End Property

    ''' <summary>
    ''' Wenn hier eine Webadresse angegeben wird, erscheint das Hilfe-Symbol in der Titelzeile und leitet den Benutzer, wenn geklickt, auf die jeweilige Webadresse
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Overrides ReadOnly Property HelpUrl() As String
        Get
            Return ""
        End Get
    End Property

    ''' <summary>
    ''' In diesem Beispiel nicht relevant
    ''' </summary>
    ''' <remarks></remarks>
    Protected Overrides Sub LoadDataFromKlassenObjekt()
    End Sub

    ''' <summary>
    ''' In diesem Beispiel nicht relevant
    ''' </summary>
    ''' <remarks></remarks>
    Protected Overrides Sub SaveDataToKlassenObjekt()
    End Sub

    ''' <summary>
    ''' In diesem Beispiel nicht relevant
    ''' </summary>
    ''' <param name="session"></param>
    ''' <remarks></remarks>
    Public Overrides Sub SaveDataToSession(ByVal session As System.Web.SessionState.HttpSessionState)
    End Sub


#End Region

End Class