﻿Imports globalefunktionen

Partial Class WebParts_Adresse_HalloWeltDB 'Die Klasse des Webparts muss mit der Angabe in der ".ascx"-Datei übereinstimmen, außerdem Bestimmt der Klassenname ob das Webpart z.B. ein anderes Webpart überschreibt. (Falls z.B. das Webpart "Anschrift.ascx" überschrieben werden soll würde die Klasse "WebParts_Adresse_WPAnschrift" sein)
    Inherits myWebControls.myWebPart

#Region " Testklasse "

    ''' <summary>
    ''' Um von verschiedenen Webparts auf diese Klasse zugreifen zu können muss das Steuerelement meineKlassen.ascx und .vb im "Client"-Verzeichnis abgelegt werden.
    ''' </summary>
    ''' <remarks></remarks>
    Public Class clsTest_Adresse
        Inherits Klassen.clsAdresse

        Public Sub New()
            MyBase.New()
        End Sub

        Public Sub New(ByVal ID As Integer)
            MyBase.New(ID)
        End Sub

        Protected Overrides ReadOnly Property NameTabelle() As String
            Get
                Return "Adresse"
            End Get
        End Property

        ''' <summary>
        ''' Neue Testeigenschaft.
        ''' </summary>
        ''' <value></value>
        ''' <returns></returns>
        ''' <remarks></remarks>
        Public Property Testeigenschaft() As String
            Get
                Return GetString("Testeigenschaft")
            End Get
            Set(ByVal value As String)
                SetString("Testeigenschaft", value)
            End Set
        End Property

    End Class

#End Region

#Region " Prozeduren "

    ''' <summary>
    ''' Diese Funktion wird benutzt um Daten aus dem aktuellen Klassen-Objekt zu laden.
    ''' </summary>
    ''' <remarks></remarks>
    Protected Overrides Sub LoadDataFromKlassenObjekt()
        Dim Adresse As Klassen.clsAdresse = TryCast(Me.KlassenObjekt, Klassen.clsAdresse)
        Dim TestAdresse As clsTest_Adresse = New clsTest_Adresse(Adresse.ID) ' Hier wird die lokale Klasse verwendet
        Dim TestAdresseGlobal As ASP.meineklassen_ascx.clsTest_Adresse = New ASP.meineklassen_ascx.clsTest_Adresse(Adresse.ID) 'So würde der Globale Verweis aussehen

        globalefunktionen.LoadDataFromKlassenObjekt(TestAdresse.Testeigenschaft, "Text", matbTesteigenschaft, Session, Request.Url.OriginalString & Me.Title)

        '//////Es ist nicht zwangsläufig erforderlich eine neue Klasse zu erstellen, nur um eine neue Eigenschaft zu pflegen. Werte können auch über die folgenden Funktionen gelesen und geschrieben werden:
        'Adresse.GetString("Testeigenschaft")
        'Adresse.SetString("Testeigenschaft", matbTesteigenschaft.Text)
        'oder z.B. Adresse.GetInteger() usw.
    End Sub

    ''' <summary>
    ''' Diese Funktion wird benutzt um Daten in das aktuelle Klassen-Objekt zu speichern.
    ''' </summary>
    ''' <remarks></remarks>
    Protected Overrides Sub SaveDataToKlassenObjekt()
        Dim Adresse As Klassen.clsAdresse = TryCast(Me.KlassenObjekt, Klassen.clsAdresse)
        Dim TestAdresse As clsTest_Adresse = New clsTest_Adresse(Adresse.ID)
        Dim TestAdresseGlobal As ASP.meineklassen_ascx.clsTest_Adresse = New ASP.meineklassen_ascx.clsTest_Adresse(Adresse.ID)

        globalefunktionen.SaveDataToKlassenObjekt(TestAdresse, "Testeigenschaft", "matbTesteigenschaft.Text", matbTesteigenschaft.Text, Session, Request.Url.OriginalString & Me.Title)
    End Sub

#End Region

#Region " In diesem Beispiel nicht relevant "

    ''' <summary>
    ''' Hier kann ein Bild angegeben werden, welches im Dialog "Webpart hinzufügen" angezeigt wird
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Overrides Property CatalogIconImageUrl() As String
        Get
            Return ""
        End Get
        Set(ByVal value As String)

        End Set
    End Property

    ''' <summary>
    ''' Hier kann ein Beschreibungstext für das Webpart angegeben werden, welcher im Dialog "Webpart hinzufügen" angezeigt wird
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Overrides Property Description() As String
        Get
            Return "Hier steht die Beschreibung"
        End Get
        Set(ByVal value As String)

        End Set
    End Property

    ''' <summary>
    ''' Wird Nach dem Titel in der Titelzeile und im Dialog "Webpart hinzufügen" angezeigt
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Overrides ReadOnly Property Subtitle() As String
        Get
            Return ""
        End Get
    End Property

    ''' <summary>
    ''' Der Titel des Webparts wird in der Titelzeile, im Dialog "Webpart hinzufügen" und an weiteren Stellen angezeigt angezeigt
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Overrides Property Title() As String
        Get
            Return "Fortgeschritten - 08 Eigene Klasse oder eigener Datenbankwert"
        End Get
        Set(ByVal value As String)

        End Set
    End Property

    ''' <summary>
    ''' Hier kann ein Bild angegeben werden, welches in der Titelzeile des Webparts angezeigt wird
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Overrides Property TitleIconImageUrl() As String
        Get
            Return ""
        End Get
        Set(ByVal value As String)

        End Set
    End Property

    ''' <summary>
    ''' Hier kann ein Webadresse angegeben werden, welche die Titelleiste in einen Link umwandelt, diese Funktion wird allerdings bisher nicht verwendet
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Overrides Property TitleUrl() As String
        Get
            Return ""
        End Get
        Set(ByVal value As String)

        End Set
    End Property

    ''' <summary>
    ''' Wenn hier eine Webadresse angegeben wird, erscheint das Hilfe-Symbol in der Titelzeile und leitet den Benutzer, wenn geklickt, auf die jeweilige Webadresse
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Overrides ReadOnly Property HelpUrl() As String
        Get
            Return ""
        End Get
    End Property

    ''' <summary>
    ''' In diesem Beispiel nicht relevant
    ''' </summary>
    ''' <param name="session"></param>
    ''' <remarks></remarks>
    Public Overrides Sub SaveDataToSession(ByVal session As System.Web.SessionState.HttpSessionState)
    End Sub

#End Region

End Class