﻿Imports globalefunktionen

Partial Class WebParts_Adresse_HalloWelt 'Die Klasse des Webparts muss mit der Angabe in der ".ascx"-Datei übereinstimmen, außerdem Bestimmt der Klassenname ob das Webpart z.B. ein anderes Webpart überschreibt. (Falls z.B. das Webpart "Anschrift.ascx" überschrieben werden soll würde die Klasse "WebParts_Adresse_WPAnschrift" sein)
    Inherits myWebControls.myWebPart

#Region " Eigenschaften "

    ''' <summary>
    ''' Hier kann ein Bild angegeben werden, welches im Dialog "Webpart hinzufügen" angezeigt wird
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Overrides Property CatalogIconImageUrl() As String
        Get
            Return "WebParts/MostSpecific/Adresse/HalloWelt.png"
        End Get
        Set(ByVal value As String)

        End Set
    End Property

    ''' <summary>
    ''' Hier kann ein Beschreibungstext für das Webpart angegeben werden, welcher im Dialog "Webpart hinzufügen" angezeigt wird
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Overrides Property Description() As String
        Get
            Return "Hier steht die Beschreibung"
        End Get
        Set(ByVal value As String)

        End Set
    End Property

    ''' <summary>
    ''' Wird Nach dem Titel in der Titelzeile und im Dialog "Webpart hinzufügen" angezeigt
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Overrides ReadOnly Property Subtitle() As String
        Get
            Return "Hi!"
        End Get
    End Property

    ''' <summary>
    ''' Der Titel des Webparts wird in der Titelzeile, im Dialog "Webpart hinzufügen" und an weiteren Stellen angezeigt angezeigt
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Overrides Property Title() As String
        Get
            Return "HalloWelt"
        End Get
        Set(ByVal value As String)

        End Set
    End Property

    ''' <summary>
    ''' Hier kann ein Bild angegeben werden, welches in der Titelzeile des Webparts angezeigt wird
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Overrides Property TitleIconImageUrl() As String
        Get
            Return "../WebParts/MostSpecific/Adresse/icon.png"
        End Get
        Set(ByVal value As String)

        End Set
    End Property

    ''' <summary>
    ''' Hier kann ein Webadresse angegeben werden, welche die Titelleiste in einen Link umwandelt, diese Funktion wird allerdings bisher nicht verwendet
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Overrides Property TitleUrl() As String
        Get
            Return ""
        End Get
        Set(ByVal value As String)

        End Set
    End Property

    ''' <summary>
    ''' Wenn hier eine Webadresse angegeben wird, erscheint das Hilfe-Symbol in der Titelzeile und leitet den Benutzer, wenn geklickt, auf die jeweilige Webadresse
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Overrides ReadOnly Property HelpUrl() As String
        Get
            Return "http://www.unierm.de"
        End Get
    End Property

#End Region

#Region " Prozeduren "

    ''' <summary>
    ''' Diese Funktion wird benutzt um Daten aus dem aktuellen Klassen-Objekt zu laden, in diesem Fall der Adresse, welche geöffnet ist.
    ''' </summary>
    ''' <remarks></remarks>
    Protected Overrides Sub LoadDataFromKlassenObjekt()
        'Me.KlassenObjekt enthält das aktuelle Objekt der Seite
        Dim Adresse As Klassen.clsAdresse = TryCast(Me.KlassenObjekt, Klassen.clsAdresse)

        'Die Daten werden aus der Adresse in das Steuerlement geladen, im Hintergrund werden zudem Werte in der Session gesetzt um Seitenaktualisierungen zu verbessern:
        If Not Adresse.Telefon Is Nothing Then
            '                                         Der Wert v     Das Steuerlement v                Der Session Index v
            '                                Eigenschaft des Steuerlements v         Die Session v
            globalefunktionen.LoadDataFromKlassenObjekt(Adresse.Telefon, "Text", matbTelefon, Session, Request.Url.OriginalString & Me.Title)
        End If
        If Not Adresse.Geburtsdatum = Nothing Then
            globalefunktionen.LoadDataFromKlassenObjekt(Adresse.Geburtsdatum, "Text", matbGeburtstagdatum, Session, Request.Url.OriginalString & Me.Title)
        End If
        If Not Adresse.Internetadresse Is Nothing Then
            globalefunktionen.LoadDataFromKlassenObjekt(Adresse.Internetadresse, "Text", matbInternet, Session, Request.Url.OriginalString & Me.Title)
        End If
    End Sub

    ''' <summary>
    ''' Diese Funktion wird benutzt um Daten in das aktuelle Klassen-Objekt zu speichern.
    ''' </summary>
    ''' <remarks></remarks>
    Protected Overrides Sub SaveDataToKlassenObjekt()
        Dim Adresse As Klassen.clsAdresse = TryCast(Me.KlassenObjekt, Klassen.clsAdresse)

        'Die Daten werden aus dem Steuerlement in die Adresse gespeichert:

        '                          Das Klassenobjekt v   Eigenschaft&Steuerlement v      Der Wert v                  Der Session Index v
        '                               Eigenschaft der Klasse v                                   Die Session v
        globalefunktionen.SaveDataToKlassenObjekt(Adresse, "Telefon", "matbTelefon.Text", matbTelefon.Text, Session, Request.Url.OriginalString & Me.Title)
        If Microsoft.VisualBasic.IsDate(matbGeburtstagdatum.Text) = True Then
            globalefunktionen.SaveDataToKlassenObjekt(Adresse, "Geburtsdatum", "matbGeburtstagdatum.Text", matbGeburtstagdatum.Text, Session, Request.Url.OriginalString & Me.Title)
        End If
        'globalefunktionen.SaveDataToKlassenObjekt(Adresse, "Internetadresse", "matbInternet.Text", matbInternet.Text, Session, Request.Url.OriginalString & Me.Title) 'Nicht nötig, da die Textbox aktuell nur gelesen werden kann
    End Sub

#End Region

#Region " In diesem Beispiel nicht relevant "

    ''' <summary>
    ''' In diesem Beispiel nicht relevant
    ''' </summary>
    ''' <param name="session"></param>
    ''' <remarks></remarks>
    Public Overrides Sub SaveDataToSession(ByVal session As System.Web.SessionState.HttpSessionState)
    End Sub

#End Region

End Class